<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoPerformanceReport ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoPerformanceReport extends AbstractStructArrayBase
{
    /**
     * The EcoPerformanceReport
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoPerformanceReport[]
     */
    public $EcoPerformanceReport;
    /**
     * Constructor method for ArrayOfEcoPerformanceReport
     * @uses ArrayOfEcoPerformanceReport::setEcoPerformanceReport()
     * @param \StructType\EcoPerformanceReport[] $ecoPerformanceReport
     */
    public function __construct(array $ecoPerformanceReport = array())
    {
        $this
            ->setEcoPerformanceReport($ecoPerformanceReport);
    }
    /**
     * Get EcoPerformanceReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoPerformanceReport[]|null
     */
    public function getEcoPerformanceReport()
    {
        return isset($this->EcoPerformanceReport) ? $this->EcoPerformanceReport : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEcoPerformanceReport method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEcoPerformanceReport method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEcoPerformanceReportForArrayConstraintsFromSetEcoPerformanceReport(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEcoPerformanceReportEcoPerformanceReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcoPerformanceReportEcoPerformanceReportItem instanceof \StructType\EcoPerformanceReport) {
                $invalidValues[] = is_object($arrayOfEcoPerformanceReportEcoPerformanceReportItem) ? get_class($arrayOfEcoPerformanceReportEcoPerformanceReportItem) : sprintf('%s(%s)', gettype($arrayOfEcoPerformanceReportEcoPerformanceReportItem), var_export($arrayOfEcoPerformanceReportEcoPerformanceReportItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EcoPerformanceReport property can only contain items of type \StructType\EcoPerformanceReport, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EcoPerformanceReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoPerformanceReport[] $ecoPerformanceReport
     * @return \ArrayType\ArrayOfEcoPerformanceReport
     */
    public function setEcoPerformanceReport(array $ecoPerformanceReport = array())
    {
        // validation for constraint: array
        if ('' !== ($ecoPerformanceReportArrayErrorMessage = self::validateEcoPerformanceReportForArrayConstraintsFromSetEcoPerformanceReport($ecoPerformanceReport))) {
            throw new \InvalidArgumentException($ecoPerformanceReportArrayErrorMessage, __LINE__);
        }
        if (is_null($ecoPerformanceReport) || (is_array($ecoPerformanceReport) && empty($ecoPerformanceReport))) {
            unset($this->EcoPerformanceReport);
        } else {
            $this->EcoPerformanceReport = $ecoPerformanceReport;
        }
        return $this;
    }
    /**
     * Add item to EcoPerformanceReport value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoPerformanceReport $item
     * @return \ArrayType\ArrayOfEcoPerformanceReport
     */
    public function addToEcoPerformanceReport(\StructType\EcoPerformanceReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoPerformanceReport) {
            throw new \InvalidArgumentException(sprintf('The EcoPerformanceReport property can only contain items of type \StructType\EcoPerformanceReport, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EcoPerformanceReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoPerformanceReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoPerformanceReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoPerformanceReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoPerformanceReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoPerformanceReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoPerformanceReport
     */
    public function getAttributeName()
    {
        return 'EcoPerformanceReport';
    }
}
